'+--------------------------------------------------------------------------+
'|                                                                          |
'|                               DashBoard                                  |
'|                                                                          |
'|                         GDImage Widget project                           |
'|                                                                          |
'|                    Photo-realistic gauge animation                       |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2009                             |
'|                           www.zapsolution.com                            |
'|                        pterrier@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 05-16-2009 (MM-DD-YYYY)            |
'|                        Last revised : 05-17-2009 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "DashBoard.exe"
#OPTION VERSION5

'#OPTIMIZE SIZE
'#OPTIMIZE SPEED

#RESOURCE "control.pbr"

'// Return the SKIN Author's name
DECLARE FUNCTION SK_AUTHOR() AS STRING
'// Return SKIN color set
DECLARE FUNCTION SK_ACTIVECAPTION() AS LONG       '// COLOR ACTIVE CAPTION
DECLARE FUNCTION SK_INACTIVECAPTION() AS LONG     '// COLOR INACTIVE CAPTION
DECLARE FUNCTION SK_TEXTCOLOR() AS LONG           '// COLOR TEXT
DECLARE FUNCTION SK_BTNTEXTCOLOR() AS LONG        '// COLOR BUTTON TEXT
DECLARE FUNCTION SK_POPMENUTEXT() AS LONG         '// COLOR POPUP MENU TEXT
DECLARE FUNCTION SK_POPMENUHILITE() AS LONG       '// COLOR POPUP MENU HILIGHTED TEXT
DECLARE FUNCTION SK_ACTIVEMENUBAR() AS LONG       '// COLOR MENU BAR HILIGHTED ITEM
DECLARE FUNCTION SK_INACTIVEMENUBAR() AS LONG     '// COLOR MENU BAR DEFAULT COLOR
DECLARE FUNCTION SK_CAPTIONFONT() AS STRING       '// CAPTION FONT TO USE
DECLARE FUNCTION SK_CAPTIONFONTHEIGHT() AS LONG   '// CAPTION FONT SIZE
DECLARE FUNCTION SK_PUSHBUTFONTSIZE() AS LONG     '// PUSH BUTTON FONT SIZE
DECLARE FUNCTION SK_TRACKHICOLOR() AS LONG        '// TRACK BAR HIGHLIGHTED VALUE
DECLARE FUNCTION SK_TEXTFONT() AS STRING          '// TEXT FONT TO USE
DECLARE FUNCTION SK_AEROEMULATE() AS LONG         '// CHECK IF AERO EMULATION IS ON
DECLARE FUNCTION SK_AEROBLURLEVEL() AS LONG       '// AERO BLURING LEVEL
DECLARE FUNCTION SK_AEROCOLOR() AS LONG           '// AERO GLASS COLOR
DECLARE FUNCTION SK_AEROTIMERDELAY() AS LONG      '// AERO TIMER REFRESH DELAY
DECLARE FUNCTION SK_COLORLABEL() AS STRING        '// GDIPLUS COLOR LIST FOR COLORPICKER COMBO
DECLARE FUNCTION SK_PROGRESSCOLOR() AS LONG       '// TRACK BAR PROGRESS COLOR
DECLARE FUNCTION SK_CENTERFORM() AS STRING        '// DEFAULT FORM BACKGROUND IMAGE

#INCLUDE "ZSKIN.INC"

#INCLUDE "GDIMAGE.INC"

DECLARE FUNCTION zTrace LIB "zTrace.DLL" ALIAS "zTrace" (zMessage AS ASCIIZ) AS LONG
'DECLARE FUNCTION zDebug LIB "zTrace.DLL" ALIAS "zDebug" (zMessage AS ASCIIZ) AS LONG

DECLARE FUNCTION AddFontResource LIB "GDI32.DLL" ALIAS "AddFontResourceA" (BYREF ASCIIZ) AS LONG

%VK_PRIOR                 = &H21
%VK_NEXT                  = &H22
%VK_END                   = &H23
%VK_HOME                  = &H24
%VK_LEFT                  = &H25
%VK_NUMPAD4               = &H64
%VK_UP                    = &H26
%VK_NUMPAD8               = &H68
%VK_RIGHT                 = &H27
%VK_NUMPAD6               = &H66
%VK_DOWN                  = &H28
%VK_NUMPAD2               = &H62

'------------------------------------------------------------------------------------------
' LOCAL section
'------------------------------------------------------------------------------------------

%XMIN_SIZE              = 800 '// Window minimum width
%YMIN_SIZE              = 600 '// Window minimum height

%GL_SizeX               = 384 '// X size of the OpenGL object
%GL_SizeY               = 384 '// Y size of the OpenGL object
%TIMER_DELAY            = 40  '// Timer delay (animation speed)

%ID_BACKGROUND          = -999
%ID_CTRL                = -1

%IDS_WINDBACK           = 1
%IDS_WINDARROW          = 2
%IDS_WINDDIGIT1         = 3
%IDS_WINDDIGIT2         = 4
%IDS_WINDLABEL          = 5

%IDS_COMPASSBACK        = 6
%IDS_COMPASSARROW       = 7
%IDS_CAPEKNTS           = 8
%IDS_CAPE               = 9
%IDS_KNTS               = 10
%IDS_COMPASSLABEL       = 11

%IDS_FLOWBACK           = 12
%IDS_FLOWARROW          = 13
%IDS_FLOWSPEED          = 14
%IDS_FLOWLABEL          = 15

%IDS_TEMPERATURE        = 16
%HID_TEMPPROGRESS       = 17
%IDS_TEMPPROGRESS       = 18
%IDS_TEMPMASK           = 19
%IDS_TEMPCELCIUS        = 20
%IDS_TEMPLABEL          = 21

%IDS_DEPTHBACK          = 22
%IDS_DEPTHCURSOR        = 23
%IDS_DEPTHTEXT          = 24
%IDS_DEPTHLABEL         = 25

%IDS_LATITUDE           = 26
%IDS_LONGITUDE          = 27

%IDS_WHEEL1             = 28
%IDS_WHEEL2             = 29
%IDS_MF_FISH            = 30

%ID_FRAMEBUTTON         = -10
%ID_RESET               = -12


%ID_BACK_LIST           = -36

%ID_BTN_ABOUT           = -37
%ID_STATUSBAR           = -38
%ID_STATUSTIP           = -39

%ID_BTN_BACKL           = -42
%ID_BTN_BACKR           = -43
%ID_LIB_BACK            = -44

%ID_CLOCK               = -45
%ID_BTN_HELP            = -46

%ID_COMPOSITED          = -47
%ID_STATUSMESSAGE       = -49

%ID_MULTIFRAME          = -59

$LCD_FONT               = "ARIAL" '// "LCD"
%LCD_FONTSIZE           = 17      '// 20 <-- use this value with the "LCD" font (see "LCD-U__.TTF")

GLOBAL gnCtrl1, gMainWnd AS DWORD
GLOBAL gnFocusID AS LONG
GLOBAL grAspect, grWasZoom AS SINGLE
GLOBAL gnWasAngle, gnWasAlpha, gnWasBrightness, gnWasContrast, gnWasRed, gnWasGreen, gnWasBlue, gnWasHue AS LONG
GLOBAL gnSeedAngle, gnPrevAngle AS LONG

GLOBAL gnFontColor AS LONG

SUB ListDeleteAll(BYVAL hList AS LONG)
    IF hList THEN CALL SendMessage(hList, %LB_RESETCONTENT, 0, 0)
END SUB

'SUB ListDelete(BYVAL hList AS LONG, BYVAL nIndex AS LONG)
'    IF nIndex > 0 THEN DECR nIndex '// Because ListBox is zero based
'    IF hList THEN CALL SendMessage(hList, %LB_DELETESTRING, nIndex, 0)
'END SUB

SUB ListSelectPlus(BYVAL hList AS LONG, BYVAL nSelected AS LONG)
    IF nSelected > 0 THEN DECR nSelected '// Because ListBox is zero based
    IF hList THEN CALL SendMessage(hList, %LB_SETCURSEL, nSelected, 0)
END SUB

FUNCTION ListFindString(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    LOCAL nIndex AS LONG
    nIndex = SendMessage(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    IF nIndex > -1 THEN INCR nIndex: FUNCTION = nIndex
END FUNCTION

FUNCTION ListCount(BYVAL hList AS LONG) AS LONG
    IF hList THEN FUNCTION = SendMessage(hList, %LB_GETCOUNT, 0, 0)
END FUNCTION

FUNCTION ListGetCursel(BYVAL hList AS LONG) AS LONG
    LOCAL nSelected AS LONG
    IF hList THEN
       nSelected = SendMessage(hList, %LB_GETCURSEL, 0, 0)
       IF nSelected > -1 THEN INCR nSelected '// Because ListBox is zero based
    END IF
    FUNCTION = nSelected
END FUNCTION

FUNCTION ListAdd(BYVAL hList AS LONG, zTmp AS ASCIIZ) AS LONG
    IF hList THEN
       IF LEN(zTmp) THEN FUNCTION = SendMessage(hList, %LB_ADDSTRING, 0, VARPTR(zTmp))
    END IF
END FUNCTION

FUNCTION ListGetText(BYVAL hList AS LONG, BYVAL ITEM AS LONG) AS STRING
    LOCAL sItem AS STRING, nLEN AS LONG
    IF ITEM > 0 THEN
       DECR ITEM
       nLEN = SendMessage(hList, %LB_GETTEXTLEN, ITEM, 0)
       sItem = SPACE$(nLEN)
       CALL SendMessage(hList, %LB_GETTEXT, ITEM, BYVAL STRPTR(sItem))
       FUNCTION = sItem
    END IF
END FUNCTION

FUNCTION GetSetGLmemDC(BYVAL hDC AS LONG, BYVAL RW AS LONG) AS LONG
    STATIC WasDC AS LONG
    IF RW THEN WasDC = hDC
    FUNCTION = WasDC
END FUNCTION
FUNCTION GLmemDC() AS LONG
    FUNCTION = GetSetGLmemDC(0, 0)
END FUNCTION

'// Main entry point
FUNCTION WINMAIN (BYVAL hInstance     AS LONG, _
                  BYVAL hPrevInstance AS LONG, _
                  BYVAL lpCmdLine     AS ASCIIZ PTR, _
                  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg         AS tagMsg
    LOCAL wc          AS WndClassEx
    LOCAL zClass      AS ASCIIZ * 80
    LOCAL dwExStyle   AS DWORD
    LOCAL dwStyle     AS DWORD
    LOCAL rc          AS RECT
    LOCAL x           AS LONG
    LOCAL y           AS LONG
    LOCAL hMutex      AS DWORD
    LOCAL hFound      AS DWORD
'
    LOCAL hWinXP_Lib           AS LONG ' Handle to WinXP Theme DLL
    LOCAL hWinXP_IsThemeActive AS LONG ' Handle to WinXP's IsThemeActive function
    LOCAL IsInitialized        AS LONG
    LOCAL hGDIplus             AS LONG ' GDIPLUS

    zClass = "ZIMAGE3D"
'
    hMutex = CreateMutex(BYVAL %Null, 0, zClass)
    IF hMutex THEN
       IF GetLastError = %ERROR_ALREADY_EXISTS THEN
          DO
             hFound = FindWindow(zClass, ""): IF hFound THEN EXIT DO
             WHILE PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): WEND
          LOOP
          IF IsIconic(hFound) THEN CALL ShowWindow(hFound, %SW_RESTORE)
          CALL SetForeGroundWindow(hFound)
          FUNCTION = 0
          EXIT FUNCTION
       END IF
    END IF

    CALL zSplitN(zExeName(), "", MyTitle$)
    MyTitle$ = PARSE$(MyTitle$, ".", 1)
'   // Check first for a valid OS version (at least XP)
    IF zOsVersion < 501 THEN
       MSGBOX zSysErrorMessage(197),,MyTitle$
       EXIT FUNCTION
    END IF

    wc.cbSize = SIZEOF(wc)
    IsInitialized = GetClassInfoEx(zsInstance(), zClass, wc)
    IF IsInitialized    = 0 THEN
       wc.cbSize        = SIZEOF(wc)
       wc.style         = %CS_HREDRAW OR %CS_VREDRAW OR %CS_DBLCLKS ' OR %CS_DROPSHADOW
       wc.lpfnWndProc   = CODEPTR(WndProc)
       wc.cbClsExtra    = 0
       wc.cbWndExtra    = %EXTEND_EXTRA * 4
       wc.hInstance     = zsInstance()
       wc.hIcon         = LoadIcon(wc.hInstance, "PROGRAM")
       wc.hCursor       = LoadCursor(%NULL, BYVAL %IDC_ARROW)
       wc.hbrBackground = %NULL
       wc.lpszMenuName  = %NULL
       wc.lpszClassName = VARPTR(zClass)
       wc.hIconSm       = wc.hIcon
       IF RegisterClassEx(wc) THEN IsInitialized = %TRUE
    END IF
'
    IF IsInitialized THEN


'LOCAL nRet AS LONG, szFile AS ASCIIZ * 260
'szFile = zsExePath() + "LCD-U__.ttf"
'nRet = AddFontResource(szFile)
'zTrace(str$(nRet))
'IF nRet THEN
'A$ = "D:\Showroom\DashBoard\LCD-U__.ttf"
'B$ = "c:\Windows\fonts\LCD-U__.ttf"
'FileCopy A$, B$
''FileCopy "D:\Showroom\DashBoard\LCD-U__.ttf", "c:\Windows\fonts\"LCD-U__.ttf"
''CALL zSetReg(&H80000002???, "SOFTWARE\Microsoft\Windows NT\CurrentVersion\Fonts", "LCD Ultra (True Type)", "LCD-U__TTF")
'SendMessage(&HFFFFFFFF???, &H1D, 0, 0)
'END IF

     '************************************************************************************
     ' Load the GDImage.dll
       IF RegisterGDImageClass() = 0 THEN
          FUNCTION = 99:  EXIT FUNCTION ' If it fails to register then return ERROR = 99
       END IF
     '************************************************************************************

     ' Load the WinXP Theme support (if applicable)
       hWinXP_Lib = LoadLibrary("UxTheme.dll")
       IF hWinXP_Lib THEN
          hWinXP_IsThemeActive = GetProcAddress(hWinXP_Lib, "IsThemeActive")
       END IF
'
       CALL InitCommonControls
'
'      // Init GDIPLUS
       hGDIplus = zGdipStart()

     ' Window Extended Style
       dwExStyle = 0 ' %WS_EX_LAYERED '// Let the OS take care of the region for us (Doesn't work on XP)
     ' Windows Style, avoid using %WS_CLIPSIBLINGS OR %WS_CLIPCHILDREN with the Skin Engine
       dwStyle = %WS_POPUP ' OR %WS_CLIPCHILDREN OR %WS_CLIPSIBLINGS
'
       CALL SetRect(rc, 0, 0, %XMIN_SIZE, %YMIN_SIZE)
'      // Note: indeed we don't need AdjustWindowRectEx, because we use do not use a non-client area
'      // but it won't hurt anything to keep it, in case we change our mind ;)
       CALL AdjustWindowRectEx(rc, dwStyle, %FALSE, dwExStyle)  ' Adjust Window To True Requested Size
'
       x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - rc.nRight - rc.nLeft) \ 2, 0)
       y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - rc.nBottom - rc.nTop) \ 2, 0)
'
     ' Create The Window
       MyTitle$ = EXE.NAME$
       gMainWnd = CreateWindowEx(dwExStyle, _         ' Extended Style For The Window
                              zClass, _               ' Class Name
                              (MyTitle$), _           ' Window Title
                              dwStyle, _              ' Defined Window Style
                              x, y, _                 ' Window Position
                              rc.nRight - rc.nLeft, _ ' Calculate Window Width
                              rc.nBottom - rc.nTop, _ ' Calculate Window Height
                              %NULL, _                ' No Parent Window
                              %NULL, _                ' No Menu
                              wc.hInstance, _         ' Instance
                              BYVAL %NULL)            ' Dont Pass Anything To WM_CREATE
'
       IF gMainWnd THEN

          IF (dwExStyle AND %WS_EX_LAYERED) THEN '// Warning this doesn't work on XP (only on VISTA and Windows 7)
             CALL SetLayeredWindowAttributes(gMainWnd, RGB(255,0,255), 255, %LWA_ALPHA OR %LWA_COLORKEY)
          END IF

        ' Apply WinXP Theme support
          LOCAL lRes AS LONG, pProc AS DWORD
          IF hWinXP_IsThemeActive THEN
             CALL DWORD hWinXP_IsThemeActive USING IsThemeActive TO lRes
             IF lRes  THEN pProc = GetProcAddress(lRes, "EnableThemeDialogTexture")
             IF pProc THEN CALL DWORD pProc USING EnableDialogTheme(gMainWnd, &H01 OR &H02 OR &H04 OR &H06)
          END IF

'         // Load SKIN components and create SYS buttons
          CALL zInitSkin(gMainWnd, zsExePath() + "DashBoard.zsk")

'         // Add the child controls being used by the application
          CALL AddChildControls()

          CALL GDImageEnableEvents(gnCtrl1)
          CALL GDImageBackground()

'         // This is the place where we create all the sprites being used into the GDImage control
          CALL GDImageCreateWidgets()

'         // *************************************************
'         // Show main window
'         // Create region and paint controls to double buffer
'         // *************************************************
          CALL zShowMainWindow(0)

          CALL SetTimer(gMainWnd, 1, %TIMER_DELAY, %NULL)

          WHILE GetMessage(Msg, %NULL, 0, 0)  ' SK_MILLISECOND
             IF IsDialogMessage(gMainWnd, Msg) = %FALSE THEN
                CALL TranslateMessage(Msg)
                CALL DispatchMessage(Msg)
             END IF
          WEND

          CALL KillTimer(gMainWnd, 1)

          '// VERY IMPORTANT
          '// FreeUp the resources
          IF GLmemDC() THEN
             CALL DeleteObject(ZI_GetBitmapFromDC( GLmemDC() ))
             CALL DeleteDC( GLmemDC() )
          END IF
          CALL GL_DeleteContext(GL_GLDC() , GL_GLRC() )

          FUNCTION = msg.wParam

       END IF

'      // UNLOAD the WinXP Theme DLL (if necessary)
       IF hWinXP_Lib THEN CALL FreeLibrary(hWinXP_Lib)

'      // UNLOAD GDIPLUS
       CALL zGdipEnd(hGDIplus)

    END IF
'
    IF hMutex THEN CALL CloseHandle(hMutex)
'
END FUNCTION

'// Fill the bakground listbox
'// Warning: Currently only JPG files!
SUB DetectBackground()
    LOCAL hList, WashFind, hFind, BackgroundCount, nSelected AS LONG
    LOCAL fd AS WIN32_FIND_DATA
    LOCAL zTmp AS ASCIIZ * %MAX_PATH
    LOCAL zBackground AS ASCIIZ * %MAX_PATH
    LOCAL sBackgroundPath AS STRING
    LOCAL nActiveBackgroundSize AS QUAD
    LOCAL nItemSize AS QUAD

'   // Size of the current active background image
    nActiveBackgroundSize = zsFileSize((SK_CENTERFORM()))

    sBackgroundPath = zsExePath() + "Background\"

    hList = zGetMainItem(%ID_BACK_LIST)
    CALL ListDeleteAll(hList)

    WashFind = MyFindFirstFile((sBackgroundPath + "*.*"), fd)
    hFind = WashFind
    DO WHILE hFind > 0
       IF ASC(fd.cFileName) <> 46 THEN
          IF INSTR(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) THEN
             zTmp = sBackgroundPath + fd.cFileName: CALL CharLower(zTmp)
             IF INSTR(".jpg.", RIGHT$(zTmp, 4) + ".") THEN
                nItemSize = MAK(QUAD, fd.nFileSizeLow, fd.nFileSizeHigh)
                IF ListAdd(hList, zTmp) > -1 THEN
                   INCR BackgroundCount
'                  // If same size, then we assume it is our current background...
                   IF nItemSize = nActiveBackgroundSize THEN zBackground = zTmp
                END IF
             END IF
          END IF
       END IF
       hFind = FindNextFile(WashFind, fd)
    LOOP
    CALL FindClose(WashFind)

    nSelected = ListFindString(hList, zBackground)
    CALL ListSelectPlus(hList, nSelected)

    IF BackgroundCount < 2 THEN
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKL), %SW_HIDE)
       CALL ShowWindow(zGetMainItem(%ID_BTN_BACKR), %SW_HIDE)
    END IF

END SUB

'// Add child controls to main window
SUB AddChildControls()

    LOCAL hCtrl, imgW, imgH AS LONG
    LOCAL sLabel, sImageName AS STRING
    LOCAL zClass AS ASCIIZ * 16
    LOCAL vgW, vgH AS LONG
    LOCAL rw AS RECT

'   Use the same font for both Aero and Standard mode
    CALL zTEXTRENDERING(%TextRenderingHintAntiAlias, 1)

'   OpenGL section
'   Create the Visual graphic control
    vgW = 666: vgH = 536
    'vgW = 0: vgH = 0
    zClass =  $GDImageClassName ' $GLImageClassName
    Style& = %WS_CHILD OR %WS_VISIBLE 'OR %WS_HSCROLL OR %WS_VSCROLL
    StyleEx& = 0 '%WS_EX_STATICEDGE
    gnCtrl1 = CreateWindowEx(StyleEx&, _
                           zClass, _                  ' GDImage class name
                           "", _                      ' Optional full path name to picture
                           Style&, _                  ' window style
                           128, _                     ' initial x position
                           41, _                      ' initial y position
                           vgW, _                     ' Calculate Window Width
                           vgH, _                     ' Calculate Window Height
                           gMainWnd, _                ' parent window handle
                           %ID_CTRL, _                ' ControlID
                           zsInstance(), _            ' program instance handle
                           BYVAL 0)                   ' creation parameters
'   Anchor the control to match the size of the parent window
    CALL zSetAnchorMode(gnCtrl1, %ANCHOR_HEIGHT_WIDTH)

'   ___________________


    hCtrl = zFrameButton(gMainWnd, (SK_FOLDER() + "Panel.png"), "", 1, 41, 135, 538, %ID_FRAMEBUTTON, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_HEIGHT)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

'   ___________________


    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Left.png"), 32, 507, %ID_BTN_BACKL, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Previous background")
    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "Right.png"), 70, 507, %ID_BTN_BACKR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Next background")
    hCtrl = zStaticLabelEx(gMainWnd, "", 14, 543, 107, 18, %ID_LIB_BACK, SK_BTNTEXTCOLOR(), %BS_LABEL_CENTER, 1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)

'   // Change default LED's anchor mode from top right to top center
    CALL zSetAnchorMode(GetDlgItem(gMainWnd, %ID_LED), %ANCHOR_RIGHT)
    CALL zSetZorder(GetDlgItem(gMainWnd, %ID_LED), %HWND_TOP)

    hCtrl = CreateWindowEx(0, "LISTBOX", "", %WS_CHILD OR %LBS_SORT, 0, 0, 0, 0, gMainWnd, %ID_BACK_LIST, zsInstance(), BYVAL %NULL)
    CALL DetectBackground()

    hCtrl = zClockCtrl(gMainWnd, (SK_FOLDER() + "SmallClock.png"), 24, 70, 0, 0, %ID_CLOCK, &H7FCB0000, &H7F8F8F8F, %DISABLE_TIMER)
    'CALL zSetAnchorMode(hCtrl, %ANCHOR_RIGHT)
    'CALL zSetZorder(hCtrl, %HWND_TOP)
    'CALL zCreateToolTip(hCtrl, "This is a zClockCtrl")

    hCtrl = zButImage(gMainWnd, (SK_FOLDER() + "BTN_Help.png"), zCXSYSICON(0,0), zCYSYSICON(0,0), %ID_BTN_HELP, 0)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "About")

'    hCtrl = zPushButton(gMainWnd, (SK_FOLDER() + "BTN_About.png"), "", 660+8, 561, 90, 16, %ID_BTN_ABOUT, SK_BTNTEXTCOLOR(), -1, 0)
'    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_RIGHT)
'    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
'    CALL zCreateToolTip(hCtrl, "Copyright (c) " + RIGHT$(DATE$, 4) + " Patrice Terrier")

    sImageName = SK_FOLDER() + "StatusBar.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 0, %YMIN_SIZE - imgH, %XMIN_SIZE, imgH, %ID_STATUSBAR, 0)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)

    sImageName = SK_FOLDER() + "Tip.png"
    CALL ZI_GetImageSizeFromFile((sImageName), imgW, imgH)
    hCtrl = zFrameButton(gMainWnd, (sImageName), "", 6, %YMIN_SIZE - imgH - 1, imgW, imgH, %ID_STATUSTIP, 0)
    CALL ShowWindow(hCtrl, %SW_HIDE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_BOTTOM)
    hCtrl = zStaticLabelEx(gMainWnd, "", 26, %YMIN_SIZE - 19, %XMIN_SIZE - 45, 15, %ID_STATUSMESSAGE, SK_BTNTEXTCOLOR(), %BS_LABEL_LEFT, -1)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM_WIDTH)


    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Composited", 24, 432, 90, 22, %ID_COMPOSITED, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Add a shadow effect
    CALL zSetCheckButtonStatus(hCtrl, %TRUE)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zCreateToolTip(hCtrl, "Enable or Disable the composited mode")

    hCtrl = zCheckButton(gMainWnd, (SK_FOLDER() + "BTN_Check.png"), "Animation", 24, 454, 90, 22, %ID_MULTIFRAME, SK_BTNTEXTCOLOR(), 0)
    CALL zSetImageProperty(hCtrl, %PROP_USE_3D, 1) '// Use a shadow effect to enhance visibility on lighter background
    CALL zSetZorder(hCtrl, %HWND_TOP)
    CALL zSetAnchorMode(hCtrl, %ANCHOR_BOTTOM)
    CALL zCreateToolTip(hCtrl, "Sprite multi-frame")

END SUB

SUB GdimageResize()
    LOCAL lpr AS RECT, nSizeX, nSizeY AS LONG
    CALL GDImageBackground()

    CALL GetClientRect(gnCtrl1, lpr)

    'CALL ZD_GetObjectBound(%IDS_ARROW, nSizeX, nSizeY)
    'CALL ZD_SetObjectXY(%IDS_ARROW, lpr.nRight - nSizeY - 8, lpr.nBottom - nSizeY - 8, %FALSE)
    'CALL ZD_GetObjectBound(%IDS_COMPASS, nSizeX, nSizeY)
    'CALL ZD_SetObjectXY(%IDS_COMPASS, lpr.nRight - nSizeY - 8, lpr.nBottom - nSizeY - 8, %FALSE)

END SUB

SUB ResizeWindow(BYVAL hWnd AS LONG, BYVAL ChangeBackground AS LONG)
'CALL KillTimer(hWnd, 1)
    IF zComposited() THEN lRes& = zBeginDeferWindowPos(hWnd, 0)
    CALL zDrawBackground()
    CALL EnumChildWindows(hWnd, CODEPTR(AnchorEnum), lRes&)
    IF zComposited() THEN CALL zEndDeferWindowPos(hWnd, lRes&)

    IF ChangeBackground THEN
       CALL GDImageBackground()
       CALL zUpdateWindow(hWnd, 0)
    END IF
'CALL SetTimer(hWnd, 1, 30, %NULL)
END SUB

'// This is the magic place to control what is going on inside of the GDImage graphic container!
FUNCTION GDImageCallBack(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL lpr AS RECT, nRet, nObjectID, x, y, x1, y1, ObjectType, useWidth, useHeight, BoundWidth, BoundHeight AS LONG
    LOCAL x2Div2, y2Div2, useStep AS LONG

    nRet = %FALSE ' Do not stop the event processing in GDImage

    nObjectID = ZI_MouseOverObjectID()

    SELECT CASE LONG Msg

    CASE %WM_LBUTTONDOWN
         IF nObjectID THEN
            IF nObjectID > 0 THEN

            END IF
         END IF

    CASE %WM_LBUTTONUP
         IF nObjectID > 0 THEN

         END IF

    CASE %WM_RBUTTONDOWN

    CASE %WM_MOUSEMOVE
         IF nObjectID > 0 THEN
            IF ZI_IsLButtonDown() THEN

            END IF
         END IF

    CASE %WM_KEYDOWN
         nObjectID = ZI_GetObjectFocusID() '// Move the sprite that has the focus
         IF nObjectID > 0 THEN

            CALL ZD_GetObjectXY(nObjectID, x, y)
            x1 = x ' Make a copy to keep the orignal x location unchanged
            y1 = y ' Make a copy to keep the orignal y location unchanged
          ' Check accelerator keys to compute the step range
            IF ZI_IsCtrlKeyPressed THEN
               UseStep = 4
               IF ZI_IsShiftKeyPressed THEN UseStep = 16
            ELSEIF ZI_IsShiftKeyPressed THEN
               UseStep = 2
            ELSE
               UseStep = 1
            END IF

            IF ZD_GetObjectScroll(nObjectID) THEN ' If object scroll with the bitmap background
             ' Get the size of the bitmap background
               CALL ZI_GetBitmapSize(ZI_GetBMP(hWnd), useWidth, useHeight)
            ELSE
             ' Get the control client size
               CALL GetClientRect(hWnd, lpr)
               useWidth = lpr.nRight: useHeight = lpr.nBottom
            END IF
          ' Get the sprite object size
            CALL ZD_GetObjectBound(nObjectID, BoundWidth, BoundHeight)

            x2Div2 = (BoundWidth \ 2): y2Div2 = BoundHeight \ 2

            SELECT CASE wParam
            CASE %VK_HOME
                 x1 = 0
            CASE %VK_END
                 x1 = MAX&(useWidth - BoundWidth, 0)
            CASE %VK_PRIOR
                 y1 = 0
            CASE %VK_NEXT
                 y1 = MAX&(useHeight - BoundHeight, 0)
            CASE %VK_LEFT, %VK_NUMPAD4
                 IF x1 > -x2Div2 THEN x1 = MAX&(x1 - UseStep, -x2Div2)
            CASE %VK_UP, %VK_NUMPAD8
                 IF y1 > -y2Div2 THEN y1 = MAX&(y1 - UseStep, -y2Div2)
            CASE %VK_RIGHT, %VK_NUMPAD6
                 IF x1 < useWidth - x2Div2 THEN
                    x1 = MIN&(x1 + UseStep, useWidth - x2Div2)
                 END IF
            CASE %VK_DOWN, %VK_NUMPAD2
                 IF y1 < useHeight - y2Div2 THEN
                 y1 = MIN&(y1 + UseStep, useHeight - y2Div2)
                 END IF
            END SELECT

            IF x <> x1 OR y <> y1 THEN
               x = x1: y = y1
               'CALL ZD_SetObjectXY(nObjectID, x1, y1, %TRUE)
               CALL ZD_MoveLinkedObject(nObjectID, x1, y1, %TRUE)
            END IF
         END IF
    CASE %WM_KEYUP

    CASE %WM_SIZE
         CALL GDImageResize()

    CASE %WM_MOUSEWHEEL

    END SELECT

    FUNCTION = nRet
END FUNCTION

'// Main window procedure
FUNCTION WndProc(BYVAL hWnd AS LONG, BYVAL Msg AS LONG, BYVAL wParam AS LONG, BYVAL lParam AS LONG) EXPORT AS LONG
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT, p AS POINTAPI
    LOCAL hDC, hList, nItem, Img AS LONG
    LOCAL sDataString AS STRING

    IF IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) THEN
       IF ZI_IsLButtonDown() = 0 THEN CALL ShowTip(%FALSE)
    END IF

    SELECT CASE LONG Msg

    CASE %WM_GETMINMAXINFO
         LOCAL pMM AS MINMAXINFO PTR
         pMM = lParam
         @pMM.ptMinTrackSize.x = zMinTrackSizeX(0)
         @pMM.ptMinTrackSize.y = zMinTrackSizeY(0)

    CASE %WM_COPYDATA

    CASE %WM_COMMAND
         IF zButtonSysCommand(hWnd, wParam) THEN FUNCTION = 0: EXIT FUNCTION

         SELECT CASE LONG LO(INTEGER, wParam)

         CASE %ID_COMPOSITED
              CALL GDImageBackground()
              CALL ZI_UpdateWindow(gnCtrl1, %FALSE)

         CASE %ID_BTN_About
              CALL ShellExecute(BYVAL %NULL, "open", "http://www.zapsolution.com", "", "", %SW_SHOW)
              FUNCTION = 0: EXIT FUNCTION

         CASE %ID_BTN_BACKL
              hList = zGetMainItem(%ID_BACK_LIST)
              nItem = ListGetCursel(hList)
              IF nItem > 1 THEN
                 DECR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = ListCount(hList)
                 CALL ListSelectPlus(hList, nItem)
              END IF
              sDataString = ListGetText(hList, nItem)
              Img = zCreateImageFromFile((sDataString))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (sDataString), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)

                 CALL zSplitN(sDataString, "", sDataString): sDataString = MCASE$(EXTRACT$(sDataString, $Dot))
                 CALL zSetCTLText(zGetMainItem(%ID_LIB_BACK), (sDataString))

              END IF

         CASE %ID_BTN_BACKR
              hList = zGetMainItem(%ID_BACK_LIST)
              nItem = ListGetCursel(hList)
              IF nItem < ListCount(hList) THEN
                 INCR nItem
                 CALL ListSelectPlus(hList, nItem)
              ELSE
                 nItem = 1
                 CALL ListSelectPlus(hList, nItem)
              END IF
              sDataString = ListGetText(hList, nItem)
              Img = zCreateImageFromFile((sDataString))
              IF Img THEN
                 CALL zDisposeImage(zGetProperty(hWnd, %FORM_Center))
                 CALL zsFileCopy(hWnd, (sDataString), (SK_CENTERFORM()), "", 0)
                 CALL zSetProperty(hWnd, %FORM_Center, Img)
                 CALL ResizeWindow(hWnd, 1)

                 CALL zSplitN(sDataString, "", sDataString): sDataString = MCASE$(EXTRACT$(sDataString, $Dot))
                 CALL zSetCTLText(zGetMainItem(%ID_LIB_BACK), (sDataString))

              END IF

         CASE %ID_BTN_HELP

         CASE %ID_MULTIFRAME
              CALL ZD_ShowObject(%IDS_MF_FISH, zGetCheckButtonStatus(zGetMainItem(%ID_MULTIFRAME)))

         END SELECT
         IF GetFocus <> hWnd THEN CALL SetFocus(hWnd)

    CASE %WM_SIZE
         CALL ResizeWindow(hWnd, 0)

    CASE %WM_SETTEXT
'        // Windows please do your job first.
         FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
'        // Update caption
         CALL zPaintBackground(0)
'        // Repaint only the caption.
         CALL GetClientRect(hWnd, rc)
         CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
         CALL InvalidateRect(hWnd, rc, 0)
         CALL UpdateWindow(hWnd)
         EXIT FUNCTION

    CASE %WM_NCLBUTTONDBLCLK
         IF IsIconic(hWnd) = 0 THEN
            LOCAL CaptionHeight AS LONG
            p.X = LO(INTEGER, lParam): p.Y = HI(INTEGER, lParam)
            CALL ScreenToClient(hWnd, p)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, CaptionHeight)
            IF p.Y < CaptionHeight THEN
               IF IsZoomed(hWnd) THEN
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_RESTORE, 0))
               ELSE
                  CALL zButtonSysCommand(hWnd, MAKLNG(%ID_MAXIMIZE, 0))
               END IF
               FUNCTION = 0: EXIT FUNCTION
            END IF
         END IF

    CASE %WM_NCACTIVATE
         LOCAL hBut AS LONG
         hBut = GetDlgItem(hWnd, %ID_LED)
         IF hBut THEN
'           // Windows please do your job first.
            FUNCTION = DefWindowProc(hWnd, Msg, wParam, lParam)
            IF zMainWindow(0) = GetForegroundWindow THEN
               gColorCaption = SK_ACTIVECAPTION()
            ELSE
               gColorCaption = SK_INACTIVECAPTION()
            END IF
'           // Update caption
            CALL zPaintBackground(0)

'           // Repaint only the caption.
            CALL GetClientRect(hWnd, rc)
            CALL zGetImageSize(zGetProperty(hWnd, %FORM_TopMid), 0, rc.nBottom)
            CALL InvalidateRect(hWnd, rc, 0)
            CALL UpdateWindow(hWnd)

            EXIT FUNCTION
         END IF

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION

    CASE %WM_PAINT
         BeginPaint(hWnd, ps)
         CALL zPaintDoubleBuffer(hWnd, ps.hDC)
         CALL EndPaint(hWnd, ps)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_DESTROY

'        // Remove all image resource from memory
'        // Must be done just before to exit the main program in case zAddResource
'        // has been used to store image handles that are not tied to a specific control.
'        // For example: Image used in an ownerdrawn menu.
         CALL zRemoveAllImageResource()

'        // Delete Image, Bitmap and DC matching this window
         CALL zDestroyWindowResource(hWnd)

         CALL PostQuitMessage(0)
         FUNCTION = 0: EXIT FUNCTION

    CASE %WM_TIMER
         CALL RenderAnimation(hWnd)

    END SELECT

    FUNCTION = zDefWindowProc(hWnd, Msg, wParam, lParam)

END FUNCTION

SUB GDImageEnableEvents(BYVAL hGDImageCtrl AS LONG)
    LOCAL lpCallBack AS DWORD
    lpCallBack = CODEPTR(GDImageCallBack)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONUP, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_RBUTTONDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_KEYDOWN, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_KEYUP, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_MOUSEMOVE, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_NCHITTEST, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_MOUSEWHEEL, %TRUE)
    CALL ZI_EventMessageEx(hGDImageCtrl, lpCallBack, %WM_SIZE, %TRUE)
END SUB

SUB GDImageBackground()
    LOCAL lp AS POINTAPI, rc, lpr AS RECT
    LOCAL hIC, hDC, graphics, nBackground, Img, ImgW, ImgH, xP, yP, xS, yS, bmW, bmH, CtrlW, CtrlH, bBitmapFound AS LONG

    CALL GetWindowRect(gnCtrl1, lpr)
    lp.x = lpr.nLeft: lp.y = lpr.nTop
    CALL ScreenToClient(gMainWnd, lp)
    IF zGetCheckButtonStatus(zGetMainItem(%ID_COMPOSITED)) THEN

       CALL GetClientRect(gMainWnd, rc)
       CtrlW = lpr.nRight - lpr.nLeft
       CtrlH = lpr.nBottom - lpr.nTop
       nBackground = ZD_GetObjectBitmap(%ID_BACKGROUND)
       IF nBackground THEN
          bBitmapFound = -1
          CALL ZI_GetBitmapSize(nBackground, bmW, bmH)
          IF bmW < CtrlW OR bmH < CtrlH THEN bmW = 0: bmH = 0
       END IF
       IF bmW THEN
          hIC = zDisplayDC()
          hDC = CreateCompatibleDC(hIC)
          CALL SelectObject(hDC, nBackground)
          CALL DeleteDC(hIC)
       ELSE
          '// Use default 1400 x 900
          IF CtrlW > 1400 OR CtrlH > 900 THEN
             hDC = ZI_Create32bitDC(CtrlW, CtrlH, &HFF000000&)
          ELSE
             hDC = ZI_Create32bitDC(1400, 900, &HFF000000&)
          END IF
       END IF

       nBackground = ZI_GetBitmapFromDC(hDC)
       IF GdipCreateFromHDC(hDC, graphics) = 0 THEN
          CALL ZI_SetProperty(gnCtrl1, %ZI_GradientTop, 0)
          CALL ZI_SetProperty(gnCtrl1, %ZI_GradientBottom, 0)
          Img = zGetProperty(gMainWnd, %FORM_Center): CALL zGetImageSize(Img, ImgW, ImgH)
          CALL zComputeAspect(ImgW, ImgH, rc.nRight, rc.nBottom, xP, yP, xS, yS)
         '// Set up stretching QualityMode
          CALL GdipSetInterpolationMode(graphics, 2)
          CALL GdipDrawImageRectRectI(graphics, Img, xP - lp.x, yP - lp.y, xS, yS, 0, 0, ImgW, ImgH, %UnitPixel, 0)
          CALL ZD_DrawBitmapToCtrl(gnCtrl1, 0, 0, nBackground, &HFFFFFFFF, %ID_BACKGROUND, %ZS_VISIBLE)
          CALL GdipDeleteGraphics(graphics)

          CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM) '// Make sure the background is at the bottom of z-order
          CALL ZD_SetObjectLocked(%ID_BACKGROUND, %TRUE)

       END IF
       IF hDC THEN CALL DeleteDC(hDC)
    ELSE
       CALL ZI_SetProperty(gnCtrl1, %ZI_GradientTop, RGB(0,0,0))
       CALL ZI_SetProperty(gnCtrl1, %ZI_GradientBottom, RGB(128,128,128))
       IF ZD_IsObjectVisible(%ID_BACKGROUND) THEN ZD_SetObjectVisibility(%ID_BACKGROUND, %FALSE)
    END IF

END SUB

SUB ShowTip(BYVAL bShowHide AS LONG)
    LOCAL nUseState AS LONG, sMessage AS STRING
    IF bShowHide THEN
       nUseState = %SW_SHOW
       sMessage = "TIP: clic with the right mouse button to restore the default value while hover a slider."
    ELSE
       nUseState = %SW_HIDE
       sMessage = ""
    END IF
    CALL ShowWindow(zGetMainItem(%ID_STATUSTIP), nUseState)
    CALL zSetCTLText(zGetMainItem(%ID_STATUSMESSAGE), (sMessage))
END SUB

SUB DisplayMessageTip()
    IF ZI_IsLButtonDown() AND IsWindowVisible(zGetMainItem(%ID_STATUSTIP)) = 0 THEN CALL ShowTip(%TRUE)
END SUB

'// This is the callback being used for all the animations
SUB RenderAnimation(BYVAL hWnd AS LONG)', BYVAL hGLDC AS LONG, BYVAL hGLRC AS LONG)
    LOCAL lpr AS RECT
    STATIC Flip AS LONG, nX, nY, nAngle AS LONG
    STATIC sT AS DWORD

    '// Draw active frame to new memory DC
    Flip = NOT Flip
    IF Flip THEN
        CALL RedrawClock(hWnd)
        CALL RedrawFish(hWnd)
    ELSE '// Draw animated wheel

        '// SIMULATION SECTION
        '// ******************************************
        'IF sT = 0 THEN sT = GetTickCount() + 100
        'IF GetTickCount() > sT THEN
        '   sT = 0

           RANDOMIZE TIMER

           '// Depth
           CALL ZD_GetObjectXY(%IDS_DEPTHBACK, nX, nY)
           STATIC nDepthLevel, nDepthStep AS LONG
           IF nDepthLevel < 900 THEN nDepthLevel = 900: nDepthStep = 10
           nDepthLevel += nDepthStep * RND(1,3): IF nDepthLevel > 1550 THEN nDepthStep = -10
           CALL WidgetDepth(gnCtrl1, nX, nY, nDepthLevel / 10)

           '// Temperature
           CALL ZD_GetObjectXY(%IDS_TEMPERATURE, nX, nY)
           STATIC nTempLevel, nTempStep AS LONG
           IF nTempLevel < 141 THEN nTempLevel = 141: nTempStep = 1
           nTempLevel += nTempStep: IF nTempLevel > 195 THEN nTempStep = -2
           CALL WidgetTemperature(gnCtrl1, nX, nY, nTempLevel / 10)

           '// Navigation
           CALL ZD_GetObjectXY(%IDS_COMPASSBACK, nX, nY)
           STATIC nNavLevel, nNavStep AS LONG
           IF nNavLevel < 20 THEN nNavLevel = 20: nNavStep = 1
           nNavLevel += nNavStep: IF nNavLevel > 28 THEN nNavStep = -1
           CALL WidgetNavigation(gnCtrl1, nX, nY, nNavLevel)
           CALL SetCape(gnCtrl1, nX + 20, nY - 25, RND(43,45))
           CALL ZD_GetObjectXY(%IDS_COMPASSBACK, nX, nY)
           CALL SetKnts(gnCtrl1, nX + 180, nY - 25, RND(140,151) / 10)

           '// Wind
           CALL ZD_GetObjectXY(%IDS_WINDBACK, nX, nY)
           CALL WidgetWind(gnCtrl1, nX, nY, RND(210,250), RND(3,10))

           '// Flow
           CALL ZD_GetObjectXY(%IDS_FLOWBACK, nX, nY)
           STATIC nFlowAngle, nFlowStep AS LONG
           IF nFlowAngle < 90 THEN nFlowAngle = 90: nFlowStep = 4
           nFlowAngle += nFlowStep: IF nFlowAngle > 170 THEN nFlowStep = -4
           CALL WidgetFlow(gnCtrl1, nX, nY, nFlowAngle, RND(30,45) / 10)

           '// Latitude & Longitude
           CALL GetClientRect(gnCtrl1, lpr)
           nX = lpr.nRight - 16: nY = 20
           CALL SetLatitude(gnCtrl1, nX, nY, "47 37," + LTRIM$(STR$(RND(102,109))) + "' N")
           nY += 30
           CALL SetLongitude(gnCtrl1, nX, nY, "122 26," + LTRIM$(STR$(RND(62,70))) + "' W")

        'END IF
        '// ******************************************

        CALL RedrawWheel(hWnd)

    END IF

END SUB

'// Update the wheels rotation
SUB RedrawWheel(BYVAL hWnd AS LONG)
    STATIC sT AS DWORD, nAngle AS LONG
    'IF sT = 0 THEN sT = GetTickCount() + 100
    'IF GetTickCount() > sT THEN
    '    sT = 0
        nAngle += 4: IF nAngle > 359 THEN nAngle -= 360
        CALL ZD_SetObjectAngle(%IDS_WHEEL1, nAngle, %FALSE)
        CALL ZD_SetObjectAngle(%IDS_WHEEL2, 360 - nAngle, %TRUE)
    'END IF
END SUB

'// Update the clock control
SUB RedrawClock(BYVAL hWnd AS LONG)
    STATIC sT AS DWORD
    LOCAL rc AS RECT, p AS POINTAPI
    IF sT = 0 THEN sT = GetTickCount() + 1000
    IF GetTickCount() > sT THEN
       sT = 0
       '// Invalidate rectangle to paint the clock
       CALL GetWindowRect(zGetMainItem(%ID_CLOCK), rc)
       p.X = rc.nLeft: p.Y = rc.nTop: CALL ScreenToClient(hWnd, p)
       CALL SetRect(rc, p.X, p.Y, p.X + (rc.nRight - rc.nLeft), p.Y + (rc.nBottom - rc.nTop))
       CALL InvalidateRect(hWnd, rc, 0)
       CALL UpdateWindow(hWnd)
    END IF
END SUB

'// Display the animated goldfish
SUB RedrawFish(BYVAL hWnd AS LONG)
    LOCAL rc AS RECT
    STATIC x, y, stCount, ToTheRight AS LONG, sT AS DWORD
    LOCAL nW, nH, nStepX, nStepY AS LONG

    IF ZD_IsObjectVisible(%IDS_MF_FISH) THEN
      'IF sT = 0 THEN sT = GetTickCount() + 2'300
      'IF GetTickCount() > sT THEN
          CALL GetClientRect(gnCtrl1, rc)
          CALL ZD_GetObjectBound(%IDS_MF_FISH, nW, nH)
          nW = nW \ ZD_GetObjectFrameCount(%IDS_MF_FISH)
          CALL ZD_GetObjectXY(%IDS_MF_FISH, x, y)

          RANDOMIZE(TIMER)
          nStepX = 3: nStepY = (RND - 0.5) * 1.5
          y = y + nStepY
          IF ToTheRight THEN
             IF x + nW < rc.nRight + nW THEN
                x = x + nStepX
             ELSE
                IF ToTheRight THEN CALL ZD_SetObjectFlipMode(%IDS_MF_FISH, %ZD_Reverse)
                ToTheRight = 0
                x = x - nStepX
             END IF
          ELSE
             IF x > - nW THEN
                x = x - nStepX
             ELSE
                IF ToTheRight = 0 THEN CALL ZD_SetObjectFlipMode(%IDS_MF_FISH, %ZD_Reverse)
                ToTheRight = -1
                x = x + nStepX
             END IF
          END IF

          sT = 0
          INCR stCount: IF stCount > ZD_GetObjectFrameCount(%IDS_MF_FISH) THEN stCount = 1
          CALL ZD_SetObjectFrameToUse(%IDS_MF_FISH, stCount, %FALSE)
          CALL ZD_SetObjectXY(%IDS_MF_FISH, x, y, %TRUE)'FALSE)
      'END IF
    END IF

END SUB

SUB GDImageCreateWidgets()
    LOCAL lpr AS RECT
    LOCAL nBitmap, nX, nY, nW, nH, nSizeX, nSizeY, nAngle, nDigit AS LONG
    LOCAL rTemperature, rProfondeur, rSpeed AS SINGLE

    gnFontColor = ZD_ARGB(255, 5,250,138)

    CALL GetClientRect(gnCtrl1, lpr)

    '// Vent
    CALL ZI_GetImageSizeFromFile(SK_FOLDER() + "Wind.png", nW, nH)
    nX = lpr.nRight - nH - 16: nY = lpr.nBottom - nH - 16 - 20: nAngle = 360 - (30 + 119): nDigit = 0
    CALL WidgetWind(gnCtrl1, nX, nY, nAngle, nDigit)

    '// Navigation (Cape + Knts)
    CALL ZI_GetImageSizeFromFile(SK_FOLDER() + "Navigation.png", nW, nH)
    nX -= (nH + 16): nY = nY: nAngle = 0
    CALL WidgetNavigation(gnCtrl1, nX, nY, nAngle)
    CALL SetCape(gnCtrl1, nX + 20, nY - 25, 92)
    CALL SetKnts(gnCtrl1, nX + 180, nY - 25, 14.1)

    '// Flow
    CALL ZI_GetImageSizeFromFile(SK_FOLDER() + "WaterFlow.png", nW, nH)
    nX -= (nH + 16): nY = nY: nAngle = 89: rSpeed = 10.5
    CALL WidgetFlow(gnCtrl1, nX, nY, nAngle, rSpeed)

    '// Temperature
    CALL ZI_GetImageSizeFromFile(SK_FOLDER() + "Temperature.png", nW, nH)
    '//nX = lpr.nRight - nH - 16: nY = lpr.nBottom - (nH * 2) - 50
    nX = 234: nY = 86 - 20 '//lpr.nBottom - (nH * 2) - 50
    rTemperature = 18.4
    CALL WidgetTemperature(gnCtrl1, nX, nY, rTemperature)

    '// Depth
    CALL ZI_GetImageSizeFromFile(SK_FOLDER() + "Profondeur.png", nW, nH)
    nX = 43: nY = 52 - 20 '//lpr.nBottom - (nH * 2) - 50
    rProfondeur = 100.4
    CALL WidgetDepth(gnCtrl1, nX, nY, rProfondeur)

    '// Animated wheels
    nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Wheel2.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl1, 434, 160-60, nBitmap, ZD_ColorARGB(255, 0), %IDS_WHEEL1, %ZS_VISIBLE)
    CALL ZD_SetObjectLocked(%IDS_WHEEL1, %TRUE)
    CALL ZD_CloneObject(%IDS_WHEEL1, %IDS_WHEEL2, 532, 103-60)
    CALL ZD_SetObjectLocked(%IDS_WHEEL2, %TRUE)
    '// Set anchor mode
    ZD_SetObjectAnchorMode(%IDS_WHEEL1, %ANCHOR_RIGHT)
    ZD_SetObjectAnchorMode(%IDS_WHEEL2, %ANCHOR_RIGHT)

    '// Latitude & Longitude
    nX = lpr.nRight - 16: nY = 20
    CALL SetLatitude(gnCtrl1, nX, nY, "47 37,104' N")
    nY += 30
    CALL SetLongitude(gnCtrl1, nX, nY, "122 26,060' W")

    '// The animated GoldFish sprite.
    nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "GoldFish.png", nW, nH)
    CALL ZD_DrawBitmapToCtrl(gnCtrl1, lpr.nRight, 220, nBitmap, ZD_ColorARGB(255, 0), %IDS_MF_FISH, %ZS_HIDDEN)
    CALL ZD_SetObjectFrameCount(%IDS_MF_FISH, nW / nH)
    CALL ZD_SetObjectFrameToUse(%IDS_MF_FISH, 1, %FALSE)
    CALL ZD_SetObjectZorder(%IDS_MF_FISH, %ZD_ORDER_BOTTOM) '// Change Z-ORDER
    '// Set anchor mode
    ZD_SetObjectAnchorMode(%IDS_MF_FISH, %ANCHOR_RIGHT)

    '// Make sure that the composited background is still at the bottom of z-order
    CALL ZD_SetObjectZorder(%ID_BACKGROUND, %ZD_ORDER_BOTTOM)

    CALL ZI_UpdateWindow(gnCtrl1, 0)

END SUB

SUB WidgetFlow(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL nAngle AS LONG, BYVAL rSpeed AS SINGLE)
    LOCAL nBitmap, nW, nH, nFontSize, nLabelSize, nTW, nTH AS LONG
    LOCAL sUseFont, sSpeed AS STRING
    LOCAL nXF, nYF, nWF, nHF, nUseX, nUseY, nUseH AS LONG
    LOCAL sLabel, sLabelFont AS STRING

    sUseFont = $LCD_FONT
    nFontSize = %LCD_FONTSIZE
    sSpeed = LTRIM$(STR$(ROUND(rSpeed, 1)))
    IF INSTR(sSpeed, ".") = 0 THEN sSpeed += ".0"
    IF LEN(sSpeed) < 4 THEN sSpeed = "0" + sSpeed
    ZD_GetTextBound((sSpeed), (sUseFont), nFontSize, nTW, nTH, %ZD_TextHorzUp)
    nTW = nTW * 0.5

    IF ZD_GetObjectBitmap(%IDS_FLOWBACK) = 0 THEN
       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "WaterFlow.png", nW, nH)
       nUseX = nX: nUseY = nY: nUseH = nH
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nX, nY, nBitmap, ZD_ColorARGB(255, 0), %IDS_FLOWBACK, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_FLOWBACK, %TRUE)
       ZD_SetObjectLinked(%IDS_FLOWBACK, %IDS_FLOWBACK)
       ZD_SetObjectFrameCount(%IDS_FLOWBACK, 2)
       ZD_SetObjectFrameToUse(%IDS_FLOWBACK, 1, %FALSE)
       '// The static Arrow sprite.
       ZD_CloneObject(%IDS_FLOWBACK, %IDS_FLOWARROW, nX, nY)
       'ZD_SetObjectLocked(%IDS_FLOWARROW, %TRUE)
       ZD_SetObjectLinked(%IDS_FLOWARROW, %IDS_FLOWBACK)
       ZD_SetObjectFrameToUse(%IDS_FLOWARROW, 2, %FALSE)

       '// The Nds speed text
       nH = nH * 0.5
       ZD_DrawTextToCtrl(nGDImageCtrl, (sSpeed), nX + (nH - nTW) + 2, nY + nH - 11, gnFontColor, (sUseFont), nFontSize, %IDS_FLOWSPEED, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_FLOWSPEED, %TRUE)
       ZD_SetObjectLinked(%IDS_FLOWSPEED, %IDS_FLOWBACK)

       sLabel = "Water flow"
       sLabelFont = "ARIAL BLACK" ' "TREBUCHET MS"
       nLabelSize = 17
       ZD_GetTextBound((sLabel), (sLabelFont), nLabelSize, nWF, nHF, %ZD_TextHorzUp)
       nXF = nUseX + ((nUseH - nWF) / 2)
       nYF = nUseY + nUseH - 3
       ZD_DrawTextToCtrl(nGDImageCtrl, (sLabel), nXF, nYF, ZD_ARGB(255, 255,255,255), (sLabelFont), nLabelSize, %IDS_FLOWLABEL, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_FLOWLABEL, %TRUE)
       ZD_SetObjectLinked(%IDS_FLOWLABEL, %IDS_FLOWBACK)

       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_FLOWBACK,  %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_FLOWARROW, %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_FLOWLABEL, %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_FLOWSPEED, %ANCHOR_CENTER)

    ELSE
       ZD_SetObjectXY(%IDS_FLOWBACK, nX, nY, %FALSE)
       ZD_SetObjectXY(%IDS_FLOWARROW, nX, nY, %FALSE)
    END IF

    ZD_SetObjectAngle(%IDS_FLOWARROW, nAngle, %FALSE)

    ZD_GetObjectBound(%IDS_FLOWBACK, nW, nH): nH = nH * 0.5
    ZD_SetObjectXY(%IDS_FLOWSPEED, nX + (nH - nTW) + 2, nY + nH - 11, %FALSE) '// nY + 2, only if LCD font
    ZD_SetObjectText(%IDS_FLOWSPEED, (sSpeed))
END SUB

SUB SetLatitude(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL sLatitude AS STRING)
    LOCAL nW, nH, nFontSize AS LONG, sUseFont AS STRING

    nFontSize = %LCD_FONTSIZE + 10
    sUseFont = $LCD_FONT ' "EARTH"
    ZD_GetTextBound((sLatitude), (sUseFont), nFontSize, nW, nH, %ZD_TextHorzUp)
    nX -= nW '// Right justify
    IF ZD_GetObjectParent(%IDS_LATITUDE) = 0 THEN
       ZD_DrawTextToCtrl(nGDImageCtrl, (sLatitude), nX, nY, ZD_ARGB(255, 250,138,5), (sUseFont), nFontSize, %IDS_LATITUDE, %ZS_VISIBLE, 1, 0)
       ZD_SetObjectLocked(%IDS_LATITUDE, %TRUE)
       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_LATITUDE, %ANCHOR_RIGHT)
    ELSE
       ZD_SetObjectXY(%IDS_LATITUDE, nX, nY, %FALSE)
    END IF
    ZD_SetObjectText(%IDS_LATITUDE, (sLatitude))
END SUB

SUB SetLongitude(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL sLongitude AS STRING)
    LOCAL nW, nH, nFontSize AS LONG, sUseFont AS STRING

    nFontSize = %LCD_FONTSIZE + 10
    sUseFont = $LCD_FONT ' "EARTH"
    ZD_GetTextBound((sLongitude), (sUseFont), nFontSize, nW, nH, %ZD_TextHorzUp)
    nX -= nW '// Right justify
    IF ZD_GetObjectParent(%IDS_LONGITUDE) = 0 THEN
       ZD_DrawTextToCtrl(nGDImageCtrl, (sLongitude), nX, nY, ZD_ARGB(255, 250,138,5), (sUseFont), nFontSize, %IDS_LONGITUDE, %ZS_VISIBLE, 1, 0)
       ZD_SetObjectLocked(%IDS_LONGITUDE, %TRUE)
       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_LONGITUDE, %ANCHOR_RIGHT)
    ELSE
       ZD_SetObjectXY(%IDS_LONGITUDE, nX, nY, %FALSE)
    END IF
    ZD_SetObjectText(%IDS_LONGITUDE, (sLongitude))
END SUB

SUB SetCape(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL nCape AS LONG)
    LOCAL nW, nH, nFontSize AS LONG, sCape, sUseFont AS STRING

    sCape = LTRIM$(STR$(nCape))
    nFontSize = %LCD_FONTSIZE - 3
    sUseFont = $LCD_FONT
    ZD_GetTextBound((sCape), (sUseFont), nFontSize, nW, nH, %ZD_TextHorzUp)
    '//nX -= nW '// Right justify
    IF ZD_GetObjectParent(%IDS_CAPE) = 0 THEN
       ZD_DrawTextToCtrl(nGDImageCtrl, "", nX, nY, gnFontColor, (sUseFont), nFontSize, %IDS_CAPE, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_CAPE, %TRUE)
       ZD_SetObjectLinked(%IDS_CAPE, %IDS_COMPASSBACK)
       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_CAPE, %ANCHOR_CENTER)
    ELSE
       ZD_SetObjectXY(%IDS_CAPE, nX, nY, %FALSE)
    END IF
    ZD_SetObjectText(%IDS_CAPE, (sCape))
END SUB

SUB SetKnts(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL rKnts AS SINGLE)
    LOCAL nW, nH, nFontSize AS LONG, sKnts, sUseFont AS STRING

    sKnts = LTRIM$(STR$(ROUND(rKnts, 1)))
    IF INSTR(sKnts, ".") = 0 THEN sKnts += ".0"
    nFontSize = %LCD_FONTSIZE - 3
    sUseFont = $LCD_FONT
    ZD_GetTextBound((sKnts), (sUseFont), nFontSize, nW, nH, %ZD_TextHorzUp)
    nX -= nW '// Right justify
    IF ZD_GetObjectParent(%IDS_KNTS) = 0 THEN
       ZD_DrawTextToCtrl(nGDImageCtrl, "", nX, nY, gnFontColor, (sUseFont), nFontSize, %IDS_KNTS, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_KNTS, %TRUE)
       ZD_SetObjectLinked(%IDS_KNTS, %IDS_COMPASSBACK)
       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_KNTS, %ANCHOR_CENTER)
    ELSE
       ZD_SetObjectXY(%IDS_KNTS, nX, nY, %FALSE) '// nY + 2, only if LCD font
    END IF
    ZD_SetObjectText(%IDS_KNTS, (sKnts))
END SUB

SUB WidgetTemperature(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL rTemperature AS SINGLE)
    LOCAL nBitmap, nW, nH, nFontSize, nLabelSize, nTemperature AS LONG, sTemperature, sLabelFont, sUseFont AS STRING
    LOCAL nXF, nYF, nWF, nHF, nUseX, nUseY, nUseW, nUseH, nPX, nPY AS LONG
    LOCAL sLabel AS STRING

    nFontSize = %LCD_FONTSIZE + 2
    sUseFont = $LCD_FONT
    nTemperature = rTemperature '// Casting to integer
    nTemperature = (nTemperature + 4) * 4
    sTemperature = LTRIM$(STR$(rTemperature))
    IF INSTR(sTemperature, ".") = 0 THEN sTemperature += ".0"
    nPX = nX - 4 + nTemperature: nPY = nY
    IF ZD_GetObjectBitmap(%IDS_TEMPERATURE) = 0 THEN
       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Temperature.png", nW, nH)
       nUseX = nX: nUseY = nY: nUseW = nW: nUseH = nH
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nX, nY, nBitmap, ZD_ColorARGB(255, 0), %IDS_TEMPERATURE, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_TEMPERATURE, %TRUE)
       ZD_SetObjectLinked(%IDS_TEMPERATURE, %IDS_TEMPERATURE)

       '// Create a hidden object to manipulate the progress bar
       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "TempProgress.png", nW, nH)
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nPX, nPY, nBitmap, ZD_ColorARGB(255, 0), %HID_TEMPPROGRESS, %ZS_HIDDEN)
       '// Create a new object with the good size, by croping the hidden progress object bitmap.
       nBitmap = ZI_CropBitmap(ZD_GetObjectBitmap(%HID_TEMPPROGRESS), 0, 0, nW - nTemperature - 8, nH, 0)
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nPX, nPY, nBitmap, ZD_ColorARGB(255, 0), %IDS_TEMPPROGRESS, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_TEMPPROGRESS, %TRUE)
       ZD_SetObjectLinked(%IDS_TEMPPROGRESS, %IDS_TEMPERATURE)

       sLabel = "Temperature"
       sLabelFont = "ARIAL BLACK" ' "TREBUCHET MS"
       nLabelSize = 17
       ZD_GetTextBound((sLabel), (sLabelFont), 17, nWF, nHF, %ZD_TextHorzUp)
       nXF = nUseX + ((nUseW - nWF) * 0.5)
       nYF = nUseY + nUseH - 4 - 35
       ZD_DrawTextToCtrl(nGDImageCtrl, (sLabel), nXF, nYF, ZD_ARGB(255, 255,255,255), (sLabelFont), nLabelSize, %IDS_TEMPLABEL, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_TEMPLABEL, %TRUE)
       ZD_SetObjectLinked(%IDS_TEMPLABEL, %IDS_TEMPERATURE)

       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_TEMPERATURE,  %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_TEMPPROGRESS, %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_TEMPLABEL,    %ANCHOR_CENTER)

    ELSE
       ZD_SetObjectXY(%IDS_TEMPERATURE, nX, nY, %FALSE)
    END IF

    '// Create a new object with the good size, by croping the hidden progress object bitmap.
    IF ZD_GetObjectBitmap(%IDS_TEMPMASK) THEN
       ZD_GetObjectBound(%HID_TEMPPROGRESS, nW, nH)
       nBitmap = ZI_CropBitmap(ZD_GetObjectBitmap(%HID_TEMPPROGRESS), 0, 0, nW - nTemperature - 8, nH, 0)
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nPX, nPY, nBitmap, ZD_ColorARGB(255, 0), %IDS_TEMPPROGRESS, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_TEMPPROGRESS, %TRUE)
       ZD_SetObjectLinked(%IDS_TEMPPROGRESS, %IDS_TEMPERATURE)
    END IF

    IF ZD_GetObjectBitmap(%IDS_TEMPMASK) = 0 THEN
       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "TempMask.png", nW, nH)
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nX, nY, nBitmap, ZD_ColorARGB(255, 0), %IDS_TEMPMASK, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_TEMPMASK, %TRUE)
       ZD_SetObjectLinked(%IDS_TEMPMASK, %IDS_TEMPERATURE)
       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_TEMPMASK, %ANCHOR_CENTER)
    END IF

    nX += 18: nY += 62
    IF ZD_GetObjectParent(%IDS_TEMPCELCIUS) = 0 THEN
       ZD_DrawTextToCtrl(nGDImageCtrl, "", nX, nY, gnFontColor, (sUseFont), nFontSize, %IDS_TEMPCELCIUS, %ZS_VISIBLE, 0, 0)
       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_TEMPCELCIUS, %ANCHOR_CENTER)
       'ZD_SetObjectLocked(%IDS_TEMPCELCIUS, %TRUE)
       ZD_SetObjectLinked(%IDS_TEMPCELCIUS, %IDS_TEMPERATURE)
    END IF
    ZD_SetObjectXY(%IDS_TEMPCELCIUS, nX, nY, %FALSE)
    ZD_SetObjectText(%IDS_TEMPCELCIUS, (sTemperature))

END SUB

SUB WidgetDepth(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL rProfondeur AS SINGLE)
    LOCAL nBitmap, nW, nH, nFontSize, nProfondeur, nBubbleX, nBubbleY, nTX, nTY AS LONG, sProfondeur, sUseFont AS STRING
    LOCAL nXF, nYF, nWF, nHF, nUseX, nUseY, nUseW, nUseH AS LONG
    LOCAL sLabel AS STRING

    nFontSize = 10'13
    sUseFont = "ARIAL BLACK"
    'sUseFont = "ARIAL NARROW"' BLACK"
    rProfondeur = MIN(MAX(rProfondeur, 0), 294)     '// Make sure we are not out of bounds
    sProfondeur = LTRIM$(STR$(ROUND(rProfondeur, 1)))
    IF INSTR(sProfondeur, ".") = 0 THEN sProfondeur += ".0"
    nProfondeur = rProfondeur * 0.6                 '// Casting to integer
    nBubbleX = nX + 91
    nBubbleY = nY + 9 - 4 + nProfondeur

    nTX = nBubbleX + 14: nTY = nBubbleY - 3

    IF ZD_GetObjectBitmap(%IDS_DEPTHBACK) = 0 THEN
       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Profondeur.png", nW, nH)
       nUseX = nX: nUseY = nY: nUseW = nW: nUseH = nH
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nX, nY, nBitmap, ZD_ColorARGB(255, 0), %IDS_DEPTHBACK, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_DEPTHBACK, %TRUE)
       ZD_SetObjectLinked(%IDS_DEPTHBACK, %IDS_DEPTHBACK)

       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Bubble.png", nW, nH)
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nBubbleX, nBubbleY, nBitmap, ZD_ColorARGB(255, 0), %IDS_DEPTHCURSOR, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_DEPTHCURSOR, %TRUE)
       ZD_SetObjectLinked(%IDS_DEPTHCURSOR, %IDS_DEPTHBACK)

       ZD_DrawTextToCtrl(nGDImageCtrl, (sProfondeur), nTX, nTY, ZD_ColorARGB(255, 0), (sUseFont), nFontSize, %IDS_DEPTHTEXT, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_DEPTHTEXT, %TRUE)
       ZD_SetObjectLinked(%IDS_DEPTHTEXT, %IDS_DEPTHBACK)

       sLabel = "Depth"
       sUseFont = "ARIAL BLACK" ' "TREBUCHET MS"
       nFontSize = 17
       ZD_GetTextBound((sLabel), (sUseFont), nFontSize, nWF, nHF, %ZD_TextHorzUp)
       nXF = nUseX + ((nUseW - nWF) / 2)
       nYF = nUseY + nUseH - 4
       ZD_DrawTextToCtrl(nGDImageCtrl, (sLabel), nXF, nYF, ZD_ARGB(255, 255,255,255), (sUseFont), nFontSize, %IDS_DEPTHLABEL, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_DEPTHLABEL, %TRUE)
       ZD_SetObjectLinked(%IDS_DEPTHLABEL, %IDS_DEPTHBACK)

       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_DEPTHBACK,   %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_DEPTHCURSOR, %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_DEPTHTEXT,   %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_DEPTHLABEL,  %ANCHOR_CENTER)

    ELSE
       ZD_SetObjectXY(%IDS_DEPTHBACK, nX, nY, %FALSE)
       ZD_SetObjectXY(%IDS_DEPTHCURSOR, nBubbleX, nBubbleY, %FALSE)
       ZD_SetObjectXY(%IDS_DEPTHTEXT, nTX, nTY, %FALSE): ZD_SetObjectText(%IDS_DEPTHTEXT, (sProfondeur))
    END IF

END SUB

SUB WidgetWind(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL nAngle AS LONG, BYVAL nDigit AS LONG)
    LOCAL nBitmap, nW, nH, nXF, nYF, nWF, nHF, nUseX, nUseY, nUseH AS LONG, sDigit AS STRING
    LOCAL nFontSize AS LONG, sUseFont, sLabel AS STRING

    sDigit = RIGHT$("00" + LTRIM$(STR$(nDigit)), 2)
    IF ZD_GetObjectBitmap(%IDS_WINDBACK) = 0 THEN
       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "wind.png", nW, nH)
       nUseX = nX: nUseY = nY: nUseH = nH
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nX, nY, nBitmap, ZD_ColorARGB(255, 0), %IDS_WINDBACK, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_WINDBACK, %TRUE)
       ZD_SetObjectLinked(%IDS_WINDBACK, %IDS_WINDBACK)
       ZD_SetObjectFrameCount(%IDS_WINDBACK, 2)
       ZD_SetObjectFrameToUse(%IDS_WINDBACK, 1, %FALSE)
       '// The static Arrow sprite.
       ZD_CloneObject(%IDS_WINDBACK, %IDS_WINDARROW, nX, nY)
       'ZD_SetObjectLocked(%IDS_WINDARROW, %TRUE)
       ZD_SetObjectLinked(%IDS_WINDARROW, %IDS_WINDBACK)
       ZD_SetObjectFrameToUse(%IDS_WINDARROW, 2, %FALSE)
       '// The first Wind digit
       nX += 82: nY += 140
       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "digit.png", nW, nH)
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nX, nY, nBitmap, ZD_ColorARGB(255, 0), %IDS_WINDDIGIT1, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_WINDDIGIT1, %TRUE)
       ZD_SetObjectLinked(%IDS_WINDDIGIT1, %IDS_WINDBACK)
       ZD_SetObjectFrameCount(%IDS_WINDDIGIT1, 10)
       ZD_SetObjectZorder(%IDS_WINDDIGIT1, %ZD_ORDER_BOTTOM)
       '// The second Wind digit.
       nX += 18
       ZD_CloneObject(%IDS_WINDDIGIT1, %IDS_WINDDIGIT2, nX, nY)
       'ZD_SetObjectLocked(%IDS_WINDDIGIT2, %TRUE)
       ZD_SetObjectLinked(%IDS_WINDDIGIT2, %IDS_WINDBACK)
       ZD_SetObjectZorder(%IDS_WINDDIGIT2, %ZD_ORDER_BOTTOM)

       sLabel = "Wind"
       sUseFont = "ARIAL BLACK" ' "TREBUCHET MS"
       nFontSize = 17
       ZD_GetTextBound((sLabel), (sUseFont), nFontSize, nWF, nHF, %ZD_TextHorzUp)
       nXF = nUseX + ((nUseH - nWF) / 2)
       nYF = nUseY + nUseH - 4
       ZD_DrawTextToCtrl(nGDImageCtrl, (sLabel), nXF, nYF, ZD_ARGB(255, 255,255,255), (sUseFont), nFontSize, %IDS_WINDLABEL, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_WINDLABEL, %TRUE)
       ZD_SetObjectLinked(%IDS_WINDLABEL, %IDS_WINDBACK)

       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_WINDBACK,   %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_WINDARROW,  %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_WINDDIGIT1, %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_WINDDIGIT2, %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_WINDLABEL,  %ANCHOR_CENTER)

    ELSE
       ZD_SetObjectXY(%IDS_WINDBACK, nX, nY, %FALSE)
       ZD_SetObjectXY(%IDS_WINDARROW, nX, nY, %FALSE)
       nX += 82: nY += 140
       ZD_SetObjectXY(%IDS_WINDDIGIT1, nX, nY, %FALSE)
       nX += 18
       ZD_SetObjectXY(%IDS_WINDDIGIT2, nX, nY, %FALSE)
    END IF

    '// Gauche de (360 - 30)  (360 - (30 + 119))
    '// Droite de (360 - (30 + 120 + 60 + 119))  (360 - (30 + 119 + 60))
    ZD_SetObjectAngle(%IDS_WINDARROW, nAngle, %FALSE)
    nDigit = ASC(LEFT$(sDigit, 1)) - 48: IF nDigit < 1 THEN nDigit = 10
    ZD_SetObjectFrameToUse(%IDS_WINDDIGIT1, nDigit, %FALSE)
    nDigit = ASC(RIGHT$(sDigit, 1)) - 48: IF nDigit < 1 THEN nDigit = 10
    ZD_SetObjectFrameToUse(%IDS_WINDDIGIT2, nDigit, %FALSE)
END SUB

SUB WidgetNavigation(BYVAL nGDImageCtrl AS LONG, BYVAL nX AS LONG, BYVAL nY AS LONG, BYVAL nAngle AS LONG)
    LOCAL nBitmap, nBitmap2, nW2, nW, nH AS LONG
    LOCAL nFontSize, nXF, nYF, nWF, nHF AS LONG, sUseFont, sLabel AS STRING

    IF ZD_GetObjectBitmap(%IDS_COMPASSBACK) = 0 THEN
       nBitmap = ZI_CreateBitmapFromFile(SK_FOLDER() + "Navigation.png", nW, nH)

       nBitmap2 = ZI_CreateBitmapFromFile(SK_FOLDER() + "CapeKnts.png", nW2, 0)
       ZD_DrawBitmapToCtrl(nGDImageCtrl, nX + (nH - nW2) / 2, nY - 34, nBitmap2, ZD_ColorARGB(255, 0), %IDS_CAPEKNTS, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_CAPEKNTS, %TRUE)
       ZD_SetObjectLinked(%IDS_CAPEKNTS, %IDS_COMPASSBACK)

       ZD_DrawBitmapToCtrl(nGDImageCtrl, nX, nY, nBitmap, ZD_ColorARGB(255, 0), %IDS_COMPASSBACK, %ZS_VISIBLE)
       'ZD_SetObjectLocked(%IDS_COMPASSBACK, %TRUE)
       ZD_SetObjectLinked(%IDS_COMPASSBACK, %IDS_COMPASSBACK)
       ZD_SetObjectFrameCount(%IDS_COMPASSBACK, 2)
       ZD_SetObjectFrameToUse(%IDS_COMPASSBACK, 1, %FALSE)
       '// The static Arrow sprite.
       ZD_CloneObject(%IDS_COMPASSBACK, %IDS_COMPASSARROW, nX, nY)
       'ZD_SetObjectLocked(%IDS_COMPASSARROW, %TRUE)
       ZD_SetObjectLinked(%IDS_COMPASSARROW, %IDS_COMPASSBACK)
       ZD_SetObjectFrameToUse(%IDS_COMPASSARROW, 2, %FALSE)

       sLabel = "Navigation"
       sUseFont = "ARIAL BLACK" ' "TREBUCHET MS"
       nFontSize = 17
       ZD_GetTextBound((sLabel), (sUseFont), nFontSize, nWF, nHF, %ZD_TextHorzUp)
       nXF = nX + ((nH - nWF) / 2)
       nYF = nY + nH - 4
       ZD_DrawTextToCtrl(nGDImageCtrl, (sLabel), nXF, nYF, ZD_ARGB(255, 255,255,255), (sUseFont), nFontSize, %IDS_COMPASSLABEL, %ZS_VISIBLE, 0, 0)
       'ZD_SetObjectLocked(%IDS_COMPASSLABEL, %TRUE)
       ZD_SetObjectLinked(%IDS_COMPASSLABEL, %IDS_COMPASSBACK)

       '// Set anchor mode
       ZD_SetObjectAnchorMode(%IDS_COMPASSBACK,  %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_COMPASSARROW, %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_CAPEKNTS,     %ANCHOR_CENTER)
       ZD_SetObjectAnchorMode(%IDS_COMPASSLABEL, %ANCHOR_CENTER)

    ELSE
       ZD_SetObjectXY(%IDS_COMPASSBACK, nX, nY, %FALSE)
       ZD_SetObjectXY(%IDS_COMPASSARROW, nX, nY, %FALSE)
    END IF

    ZD_SetObjectAngle(%IDS_COMPASSARROW, nAngle, %FALSE)

END SUB
